import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.ImageIcon;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Color;
import javax.swing.JLabel;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.ArrayList;

public class ObserverGui extends JFrame implements ActionListener, Observable
{
    public static final int WIDTH = 500;
    public static final int HEIGHT = 200;
    public static final int TEXT_FIELD_SIZE = 30;
    private String keyData = "Data Item ";
    private ArrayList observers = new ArrayList();

    private JTextField message;

    public static void main(String[] args)
    {
        ObserverGui observerGui = new ObserverGui();
        observerGui.setVisible(true);

        ObserverEntity anObserver = new ObserverEntity();
        ObserverEntity anotherObserver = new ObserverEntity();

        observerGui.addObserver(anObserver);
        observerGui.addObserver(anotherObserver);
    }

    public ObserverGui()
    {
        super("Observer Pattern");
        setSize(WIDTH, HEIGHT);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        setBackground(Color.WHITE);
        setLayout(new BorderLayout());

        JLabel topLabel = new JLabel("Observer test");
        add(topLabel, BorderLayout.NORTH);

        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());
        JButton updateButton = new JButton("Update Key Data");
        updateButton.addActionListener(this);
        buttonPanel.add(updateButton);
        JButton exitButton = new JButton("Exit");
        exitButton.addActionListener(this);
        buttonPanel.add(exitButton);
        add(buttonPanel, BorderLayout.SOUTH);

        message = new JTextField(TEXT_FIELD_SIZE);
        add(message, BorderLayout.CENTER);
    }

    public void addObserver(Observer observer)
    {
        if (!observers.contains(observer))
        {
            observers.add(observer);
        }
    }

    public void removeObserver(Observer observer)
    {
        observers.remove(observer);
    }

    public void notifyObservers()
    {
        for (int i = 0; i < observers.size(); i++)
        {
			((ObserverEntity)observers.get(i)).notifyObservers(keyData);
		}
    }

    public void actionPerformed(ActionEvent e)
    {
       String actionCommand = e.getActionCommand();

       if (actionCommand.equals("Update Key Data"))
       {
		   // Make a change to the observed data
		   keyData+= "22";
           message.setText("Updating all observers with new key data " + keyData);
           // Notify all observers
           notifyObservers();
	   }
       else if (actionCommand.equals("Exit"))
       {
           message.setText("Exit");
		   dispose();
	   }
       else
       {
		   message.setText("Unexpected Error.");
	   }
    }
}